#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <unistd.h>
#include <vector>
#include <algorithm>
#include <cmath>
#include <sys/time.h>

using namespace std;

static const char TUNNUS[] = "bisqwit";
static const char TUNNUSu[]= "Bisqwit";
static const char SALASANA[] = "serti";
#define BURDEN_DROP 0 /* Drop everything when trouble casting */
#define FORGE_QUIT 0
#define TRY_DROP_HEAVY 0
//#define IDLETIME static_cast<unsigned> (pow(drand48(), 30) * 120)
//#define IDLETIME static_cast<unsigned> (pow(drand48(), 230) * 600)
#define IDLETIME static_cast<unsigned> (pow(drand48(), 400) * 600)
//#define IDLETIME 0
#define ETENYGETALL 1
//#define ETENYVIIVE 0
#define ETENYVIIVE static_cast<unsigned> (4E6 * pow(drand48(), 1.3)) + 1000000
#define CHARLEN 219567 /* microseconds per character */
//#define CHARLEN 0
#define FORGE_BEEP 1
static int hp,hpmax,  sp,spmax,  ep,epmax;

static bool IsPrompt(const string &s)
{
	if(sscanf(s.c_str(), "hp:%d/%d sp:%d/%d ep:%d/%d",
		&hp,&hpmax, &sp,&spmax, &ep,&epmax) != 6)
		return false;
	cerr<<"\33[1;30m"<<s<<"\33[0;37m\n";
	return true;
}

static bool DoDelay()
{
	static int c=0;
	if(drand48() < 0.3) { c=0; return true; }
	++c;
	return false;
}

/* lukee rivin sytteest ja parsii siit ylimriset pois */
static string Gets(unsigned timeout = 0)
{
	string s;
	for(;;)
	{
		if(timeout)
		{
    		fd_set fds;
    		struct timeval tv = {timeout, 0};
    		FD_ZERO(&fds);
    		FD_SET(0, &fds);
    		if(!select(1, &fds, NULL, NULL, &tv))
    		{
    			s = "";
    			return s;
    		}
    		timeout -= tv.tv_sec;
		}
		{char Buf[4096]; if(!fgets(Buf, sizeof Buf, stdin))throw 2; s=Buf; }
    	unsigned a;
    	while(s.size() && s[0]==' ')s.erase(0, 1);
    	
    	for(a=0; a<s.size(); )
    	{
    		if(s[a]=='\n' || s[a]=='\r')
    			s.erase(a, 1);
    		else if(s[a]=='\33')
    		{
    			unsigned c;
    			for(c=a; c<s.size() && (s[c]<'a' || s[c]>'z'); ++c);
    			s.erase(a, c-a+1);
    		}
    		else
    			++a;
    	}
    	while(s.size() && s[s.size()-1]==' ')s.erase(s.size()-1);

    	if(s.size()>2 && (s[0]=='[' || s[0]=='{' || s[0]=='<') && isalpha(s[1]))goto ChanMsg;
    	for(a=0; a<s.size(); ++a)if(!isalpha(s[a]))break;
    	if(a<s.size() && a>0 && s[a]==' ')
    	{
    		++a;
    		if(a < s.size() && (s[a]=='[' || s[a]=='{' || s[a]=='<'))
    		{
    	ChanMsg:
    			fprintf(stderr, "\33[0;33m%s\33[m\n", s.c_str());
    			continue;
    		}
    	}
    	
    	if(!IsPrompt(s))break;
    }
	return s;
}

static vector<string> GetExits(const string &s) /* ettii exitit rivilt */
{
	vector<string> lst;
	if(s.substr(0, 7) == "You can")return lst;
	
	if(s.size() >= 2 && s.substr(s.size()-2) == ").")
	{
		unsigned a = s.find('(');
		while(++a < s.size())
		{
			string k;
			while(s[a] != ',' && s[a] != ')')k += s[a++];
			//cerr << "\33[1mFound exit: '" << k << "'\33[m\n";
			lst.push_back(k);
			if(s[a]==')')break;
		}
	}
	random_shuffle(lst.begin(), lst.end());
	return lst;
}

static string tatakaicmd(void)
{
	bool spa = sp >= spmax*6/10 || hp <= hpmax/3;
	bool epa = ep >= epmax/3 || hp <= hpmax/3;
Retry:
	int i = -1;
	if(spa || epa)
	{
	/* SPIDER
		i = (int)(pow(drand48(), 1.3) * (5 - 1E-5));
	*/
	/* MONK */
		i = (int)(pow(drand48(), 1.5) * (2 - 1E-5)) + 10;
	}
	switch(i)
	{
		/* SPIDER */
		case 0: if(!spa)goto Retry;return "cast cause serious wounds at monster";
		case 1: if(!epa)goto Retry;return "use stab";
		case 2: if(!spa)goto Retry;return "cast cause critical wounds at monster";
		case 3: if(!spa)goto Retry;return "doclw";
		case 4: if(!spa)goto Retry;return "cast make scar at monster";
		
		/* MONK */		
		case 10: if(!epa)goto Retry;return "use kick";
		case 11: if(!spa)goto Retry;return "doclw";
		default: return "tell last 5";
	}
}

static void ForgeCheck(const string &s)
{
	if(s == "You can not take the forge."
	|| s == "You can not take a forge.")
	{
		cerr << "\33[0;1;37mFORGE! Ihaile sit :)\33[m\n";
#if FORGE_QUIT
		exit(-1);
#endif
#if BURDEN_DROP
		cout << "drop all\n";
#endif
		cout << "use ceremony\n" << flush;
#if FORGE_BEEP
		// piip * 10
		for(unsigned a=0; a<10; ++a){cerr << "\7" << flush; sleep(1); }
#endif
	}
}

static void tatakai()
{
	cout << tatakaicmd() << "\nps\ni\nkill monster\nx\n";
	for(;;)
	{
		string s = Gets();
		cerr << s << endl;
		if(s=="The maze is being re-done, please wait a while."
		|| s=="You hear a low rumble from the sewers. Then it is silent again.")throw 1;
		if(s=="You do not have enough spell points to cast the spell.")
		{
			cout << tatakaicmd() << "\n";
		}
		ForgeCheck(s);
#if BURDEN_DROP
		if(s == "Your heavy burden slows down your casting.")cout << "drop all\n";
#else
		if(s == "Your heavy burden slows down your casting.")cout << "drop all corpse\n";
#endif
		if(s=="You are done with the chant."
		|| s=="You are prepared to do the skill."
		|| s.find("You lose your concentration and ")==0)
		{
			cout << tatakaicmd() << "\n";
		}
		if(s.find("leaves") != s.npos
		|| s=="You are no longer stunned.")cout << "x\n";
		if(s.find("is DEAD, R.I.P") != s.npos
		|| s=="You are not in combat right now."
		|| s=="At whom ?"
		|| s=="Kick who?"
		|| s=="Cast make scar at what?"
		|| s=="Cast cause serious wounds at what?"
		|| s=="Cast cause critical wounds at what?"
		)
			break;
	}
}

static bool istatakai(const string &s)
{
	if(s.find("You take a dismembered entrails of") != s.npos
	|| s.find("You take a hacked yolk of") != s.npos
	|| s.find("You take a hacked entrails of") != s.npos
	|| s.find("You take a hacked corpse of") != s.npos
	|| s.find("You take a mutilated lump of") != s.npos
	|| s.find("You take a mutilated bodyparts") != s.npos
	|| s.find("You take a shredded slush of") != s.npos
	|| s.find("You take a hacked bodyparts") != s.npos)
	{
		cout << "drop all corpse\n";
	}
	if(s.find(". Too much to carry!") != s.npos)
	{
#if BURDEN_DROP
		cout << "drop all\ni\n";
#else
		cout << "drop all corpse\n";
#if TRY_DROP_HEAVY
		cout << "drop all pilum|drop all broadsword|"
		        "drop all longsword|drop all spear|"
		        "drop all gauche|drop all fauchard|"
		        "drop all blackjack|drop all ranseur|"
		        "drop all harpoon|drop all corpse|i\n";
#endif
#endif
	}
	ForgeCheck(s);
	if(s=="The maze is being re-done, please wait a while."
	|| s=="You hear a low rumble from the sewers. Then it is silent again.")throw 1;
	if(s=="The monster blocks your move."
	|| s=="You cannot leave, you have been AMBUSHED."
	)
		return true;
	return false;
}

static void Regen(unsigned forceviive = 0)
{
	bool idle = true;
CheckAgain:
	time_t endtime = 0;
	if((hp >= hpmax/2 && sp >= spmax/8 && ep > 30) || forceviive)
	{
		static unsigned counter = 0;
		if(++counter <= 5)return;
		counter = 0;
		
        unsigned sleeptime = forceviive ? forceviive : (IDLETIME);
        const char *what = forceviive ? "FORCED" : "inhimmillisyytt";
        if(!sleeptime)return;
        if(sleeptime < 10)
        {
        	cerr << "\33[0;1;37m" << sleeptime << "s paussi (" << what << ")\33[m\n";
        	sleep(sleeptime);
        	cout << "friends\n";
        	return;
        }
       	cerr << "\33[0;1;33m" << sleeptime << "s idle (" << what << ")\33[m\n";
        endtime = time(NULL) + sleeptime;
        cout << "sc on\n";
        if(ep == epmax)cout << "use mind over body\n";
        idle = true;
	}
	else
	{
		idle = false;
		cout << "sit\n";
		cout << "i\n";
		cout << "sc on\n";
ReWait: /* tick tack */
		if(idle)
			cerr << "\33[0;31mIdlataan hieman...\33[m\n";
		else
			cerr << "\33[0;31mPidetn tauko.\33[m\n";
		cout << "use ceremony\n" << flush;
	}
	bool noneed = false;
	for(;;)
	{
		string s = Gets(endtime ? endtime - time(NULL) : 0);
		cerr << s << endl;
		if(sscanf(s.c_str(), "Hp: %d (%d) Sp: %d (%d) Ep: %d (%d)",
			&hp,&hpmax, &sp,&spmax, &ep,&epmax) == 6)
		{
			if(noneed)
			{
				if((hp < hpmax && sp > spmax*3/7)
				|| (hp < hpmax/2 && sp>30))
				{
					noneed = false;
					goto Healer;
				}
			}
			goto BreakCheck;
		}
		
		#if 0
		if(s[0] == '@'
		|| (s.find(" tells ") != s.npos
		 && s.find(" you") != s.npos))
		{
			cout << "l\n";
			sleep(5);
			exit(0);
		}
		#endif
		
		if(s.find(string(TUNNUSu)+" hits") == 0)
		{
			tatakai();
			goto CheckAgain;
		}
		if(s=="The maze is being re-done, please wait a while."
		|| s=="You hear a low rumble from the sewers. Then it is silent again.")throw 1;
		if(s=="You do not have enough spell points to cast the spell.")
			goto ReWait;
#if BURDEN_DROP
		if(s == "Your heavy burden slows down your casting.")cout << "drop all\n";
#endif
		if(s=="You are done with the chant."
		|| s=="You are prepared to do the skill.")
		{	
			if((hp >= hpmax*2/3 && sp < spmax/4)
			|| sp <= 50)noneed = true;
		Healer:
			if(!noneed)
			{
				if(!idle)cerr << "\33[0;31mHealing more...\33[m\n";
				cout << "doclw\n";
			}
			continue;
		}
		if(s=="You feel fully healed."
		|| s=="You heal all of your own wounds."
		|| s.find("is not wounded.") != s.npos)
			noneed = true;
	BreakCheck:
		if(endtime)
		{
			if(time(NULL) < endtime)
			{
				cerr << "\33[0;1;31mYh " << (endtime-time(NULL)) << " sekuntia idle jljell\33[m\n";
				continue;
			}
			cout << "sc off\n";
			goto CheckAgain;
		}
		if(hp >= hpmax*2/3 && sp >= spmax/6 && ep >= epmax/6)
			break;
	}
	cout << "stand\nsc off\n";
   	for(;;)
   	{
   		string s = Gets();
   		cerr << s << endl;
   		if(s == "You stand up straight.")break;
   	}
	cerr << "\33[0;1;31mTauko pttyi.\33[m\n";
}

static void ScanRoom(const string &dir) /* rekursio */
{
	if(dir=="out")return;
	const string opposite
	  = dir=="u" ? "d"
	  : dir=="d" ? "u"
	  : dir=="w" ? "e"
	  : dir=="e" ? "w"
	  : dir=="n" ? "s"
	  : dir=="s" ? "n"
	  : dir=="sw" ? "ne"
	  : dir=="nw" ? "se"
	  : dir=="ne" ? "sw"
	  : dir=="se" ? "nw"
	  : dir=="forward" ? "backward"
	  : dir=="backward" ? "forward"
	  : "";

Retry:	
	//cerr << "\33[0;32m> " << dir << "\33[m\n";
	//cerr << "\33[0;32m> ga\33[m\n";
	Regen();
	cerr << "\33[0;1;31m-> '" << dir << "' - backdir = '" << opposite << "'\33[m\n";
	if(DoDelay())
	{
	 unsigned viiv = ETENYVIIVE + dir.size() * CHARLEN;
	 if(viiv)
	 {
	  cerr << viiv << flush;
	  usleep(viiv);
	  cerr << "\r          \r" << flush;
	}}
	cout << dir << "\n";
#if ETENYGETALL
	cout << "ga\n";
#endif
//	cout << "worship statue\n";
		
	for(;;)
	{
		string s = Gets();
		cerr << s << endl;
       	if(s=="You are so exhausted you fail to move.")
       	{
       		goto Retry;
       	}
		/*if(s.find("is looking for adventurers to eat") != s.npos)
		{
			cout << "kill monster\n";
			goto Monsu;
		}*/
		if(s.find("A strong force stops you from going") == 0)
		{
			cerr << "\33[0;1;34mEi sitten\33[m\n";
			return;
		}
		
		#if 0
		if(s[0] == '@'
		|| (s.find(" tells ") != s.npos
		 && s.find(" you") != s.npos))
		{
			cout << "l\n";
			sleep(5);
			exit(0);
		}
		#endif
		
		if(istatakai(s))
		{
Monsu:		cerr << "\33[0;1;35mOdotellaan monsterin kuolemista\33[m\n";
			tatakai();
			cerr << "\33[0;1;35mMonster kuoli, yritetn uudestaan liikkumista (suunta: '" << dir << "')\33[m\n";
			//cerr << "\33[0;32m> loot\33[m\n";
			//cerr << "\33[0;32m> ga\33[m\n";
			cout << "loot\nga\n";
			goto Retry;
		}
		vector<string> lst = GetExits(s);
		if(!lst.size())continue;
		for(unsigned a=0; a<lst.size(); ++a)
			if(lst[a] != opposite)
			{
				cerr << "\33[0;35mExits: \33[1m";
				unsigned b;
				for(b=0; b<lst.size(); ++b)
				{
					if(b > 0)cerr << "\33[21m, \33[1m";
					if(b==a)cerr << "\33[31m";
					else if(lst[b]==opposite)cerr << "\33[34m";
					else cerr << "\33[35m";
					cerr << lst[b];
				}
				cerr << "\33[m\n";				
				ScanRoom(lst[a]);
			}
		break;
	}
RetryBack:
	Regen();
	cerr << "\33[0;1;34m<- '" << opposite << "'\33[m\n";
	if(opposite.size())
	{
	    if(DoDelay())
    	{
    	 unsigned viiv = ETENYVIIVE + opposite.size() * CHARLEN;
    	 if(viiv)
    	 {
    	  cerr << viiv << flush;
    	  usleep(viiv);
    	  cerr << "\r          \r" << flush;
    	}}
        cout << opposite << "\n";
        //cerr << "\33[0;32m> " << opposite << "\33[m\n";
        for(;;)
        {
        	string s = Gets();
        	cerr << s << endl;
        	if(s=="You are so exhausted you fail to move.")
        	{
        		goto RetryBack;
        	}
        	if(istatakai(s))
        	{
        		cerr << "\33[0;1;33mOdotellaan monsterin kuolemista\33[m\n";
        		tatakai();
        		cerr << "\33[0;1;33mMonster kuoli, yritetn uudestaan liikkumista (suunta: '" << opposite << "')\33[m\n";
        		//cerr << "\33[0;32m> loot\33[m\n";
        		//cerr << "\33[0;32m> ga\33[m\n";
        		cout << "loot\nga\ndrop all corpse\n";
        		goto RetryBack;
        	}
        	if(GetExits(s).size())break;
		}
	}
}

int main(void)
{
	cout << TUNNUS << "\n"; sleep(2);
	cout << SALASANA << "\n"; sleep(2);
	
//	cout << "command doclw cast cure light wounds at me\n"
//	        "set echo off\n"
//	        "battle listen all 1\n"
//    	    "pc miaow\n";

Alustauusix:
	try
	{
		cout << "sc off\n"
		        "i\n"
		        "prompt hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> exp:<exp> kg:<weight> cash:<cash>+<bank><lf>_\n";
    	for(;;)
    	{
    		string s = Gets();
    		cerr << s << endl;
    		if(s.find("Your prompt is now") != s.npos)break;
    	}
    	ScanRoom("blook");
    	Regen(300);
    	goto Alustauusix;
	}
	catch(int i)
	{
		if(i==1)
		{
			cerr << "\33[0;44;1;37mOuch, uusiksi vaan\n";
			goto Alustauusix;
		}
	}
	cout << "sc off\n"
	        "set echo on\n"
	        "prompt <lf>hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> exp:<exp> cash:<cash>+<bank><lf>up<hour>:<min>>_\n"
	        "ld Byebye\n";
	sleep(25);
	return 0;
}


/*

prompt <lf>hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> exp:<exp> cash:<cash>+<bank><lf>up<hour>:<min>>_

prompt hp:%hp/%max_hp sp:%sp/%max_sp ep:%ep/%max_ep exp:%exp cash:%money+%savings%lf

*/